
module Diagrams
	
	class Diagram
		
		def write_tex_discovery(diag_id, output_file)
			fid = 10
			s = ("\\immediate\\openout%d=%s\n" % [fid, output_file])
			@boxes.each_with_index do |b, i|
				s += ("\\setbox0=\\hbox{%s}\n" % b.content)
				s += "\\immediate\\write%d{%s,%d,\\the\\wd0,\\the\\ht0,\\the\\dp0 ,%s}\n" % 
				[fid, diag_id, i, b.content]
			end
			s += "\\end\n"
			s
		end

		def write_latex_discovery(diag_id, output_file)
			fid = 10
			s=""
#			s +="\\documentclass{article}\\begin{document}"
			s += ("\\immediate\\openout%d=%s\n" % [fid, output_file])
			# s+= "\\ifx\\already\\empty"
			# s+="\\def\\already{1}"
			# s+= "\\newlength{\\mywd}\n"
			# s+= "\\newlength{\\myht}\n"
			# s+= "\\newlength{\\mydp}\n"
			# s+="\\fi"
			@boxes.each_with_index do |b, i|
				s += ("\\settowidth{\\mywd}{\\hbox{%s}}\n" % b.content)
				s += ("\\settoheight{\\myht}{\\hbox{%s}}\n" % b.content)
				s += ("\\settodepth{\\mydp}{\\hbox{%s}}\n" % b.content)
				s += "\\immediate\\write%d{%s,%d,\\the\\mywd,\\the\\myht,\\the\\mydp}\n" % 
				[fid, diag_id, i]
			end
			s+=("\\immediate\\closeout%d\n" % fid)
#			s+="\\end{document}"
			s
		end
		
		def read_tex_discovery(my_diag_id, s)
			s.split("\n").each do |l|
				diag_id, box_index, wd, ht, dp, text = l.split(",")
				if diag_id == my_diag_id
					puts "found box #{box_index}: #{wd} #{ht} #{dp}"
					wd,ht,dp = wd.to_f,ht.to_f,dp.to_f
					width = wd
					height = ht+dp
					puts "found box #{box_index}: #{width}x#{height}"
					i = box_index.to_i
					@boxes[i].hs.min = width
					@boxes[i].hs.shrink = 1
					@boxes[i].hs.pref = width*1.2
					@boxes[i].hs.stretch = 0.1
					@boxes[i].hs.max = 1000
					@boxes[i].vs.min = height
					@boxes[i].vs.shrink = 1
					@boxes[i].vs.pref = height*1.2
					@boxes[i].vs.stretch = 0.1
					@boxes[i].vs.max = 1000
				end
			end
		end
		
		def to_latex(job="anon_diagram")
			do_discovery = true
			
			tmp_out = "#{job}.dia"

			diag_id = "dia"
			s = write_latex_discovery(diag_id, tmp_out)

			if File.exist?(tmp_out)
				File.open(tmp_out, 'r') do |f|
					read_tex_discovery(diag_id, f.read)
				end
			end
			
			do_layout(job)
	
			@boxes.each_with_index do |b, i|
				width = b.hs.min
				height = b.vs.min
				s << ("\\framebox[%fpt]{\\rule{10pt}{%fpt}%s}"% [width,height, b.content])
			end
			
			s+="\n\nCiao\n\n"
			s 
		end
		
		
		# in points 
		def to_dev(x)
			x * 10
		end
		
		
	end
	
end



