
	Test0 = <<-EOF
+-+
|A|
+-+

+-++
|AB|
+-++

+---+
|ABC|
+---+

+----+
|ABCD|
+----+
EOF

Test1 = <<-EOF
    /---------\\ 
    |  Start  |
    \\----+----/
         |
         V
    +----+----+
    |  Init   |
    +----+----+
         |
         +<-----------+
         |            ^
         V            |
    +----+----+       |
    | Process |       |
    +----+----+       |
         |            |
         V            |
    +----+----+  yes  |
    |  more?  +-------+
    +----+----+
         | no
         V
    /----+----\\ 
    |   End   |
    \\---------/
EOF

Test2=<<-EOF
  +---------+         +---------+     +---------+
  |  Shape  |         |  Line   |     |  Point  |
  +---------+         +---------+   2 +---------+
  | draw    +<--------+ start   +----O+ x       |
  | move    +<-+      | end     |     | y       |
  +---------+   \\     +---------+     +---------+
                 \\                  
                  \\   +---------+
                   +--+ Circle  |
                      +---------+
                      | center  |
                      | radius  |
                      +---------+
EOF

Test3=(<<-EOF
                        /-----------M     yes /----------M
                    +-->| then this |--->*--->| and this |
                   /    M-----------/    |no  M----------/
/------------M    /                      |
| First this |-->+                       |
M------------/    M                      |
                   M    /---------M      V        /------M
                    +-->| or that |----->*------->| Done |
                        M---------/               M------/
EOF
).gsub(/M/,"\\")

require 'diagrams'

include Diagrams


Tests = [Test0, Test1 , Test3]

diagrams = Tests.map{|s| Diagram.new(s)}



require 'rexml/document'
include REXML

doc = Document.new 
html = Element.new 'html', doc
head = Element.new 'head', html
body = Element.new 'body', html
title = Element.new 'title', head
title << Text.new("Titolo")
style=Element.new 'link', head
style.attributes['href'] = 'style.css'
style.attributes['rel'] = 'stylesheet'
style.attributes['type'] = 'text/css'
head.add_element 'script', {'src'=>'adjust.js', 'type'=>"text/javascript"}

diagrams.each do |d|
	body << Text.new("Diagram ")
	body << d.to_html 
#\	body.add_element 'hr', {'style'=>'clear:both'}
end

File.open("tests.html",'w') do |f|
 f.write '<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC
   "-//W3C//DTD XHTML 1.1 plus MathML 2.0 plus SVG 1.1//EN"
    "http://www.w3.org/2002/04/xhtml-math-svg/xhtml-math-svg.dtd">' unless true
	doc.write(f)
end



diagrams.each_with_index do |d, i|
	File.open("test#{i}.tex", 'w') do |f|
		f.write d.to_latex
	end
end
